NB. KATSUSHIKA Hokusai(1760-1849, Edo(current Tokyo) ,Edo Era)
NB. from [Newtype komon(small bearing) Book] 1824 
NB. J Script is written by SHIMURA Masato /Dec. 2011 
NB. jcd02773@nifty.com /japla.sakura.ne.jp
NB. -----------Usage:------------------------------------
NB. <<<<<<<< Izutu Manji >>>>>>  -- 3 colors
NB. *(246 191 0;244 213 0 ;92 84 36) hokusai_im  6 7
NB. <<<<<<<< 6 hands  Manji>>>>>>>
NB. *(67 71 173; 67 90 160) hokusai_mm 6 7
NB. <<<<<<<<  Saigata >>>>>>>> 
NB. *(234 213 107;228 211 162) hokusai_s 6 7
NB. <<<<<<< Connected Manji >>>>>>>>>>
NB. * (144 93 84;230 75 107) hokusai_mt 6 7
NB. <<<<<<<<<<<<< Diamond Manji >>>>>>>>>>>>
NB. *  (0 164 116 ;169 192 135) hokusai_mc 6 7
NB. >>>>>>>>>> various  Asanoha(helm) <<<<<<<<<<<<<<<<
NB. * (144 93 84;230 75 107;0 0 0;144 93 84) hokusai_ha 6 7
NB. >>>>>>>> Hyoretsu Asanoha(various helm)<<<<<<<<
NB. *(144 93 84;230 75 107;0 0 0) hokusai_at 6 7
NB. >>>>>>> 8 hands helm <<<<<<<<<<<<<<
NB. *(120 83 62;170 179 0;170 179 120;0 83 62) hokusai_ym  7 8
NB. >>>>>>> pine leave helm <<<<<<<<<<<<
NB. *(169 192 135;151 166 30;0 0 0;255 255 255)hokusai_ma 6 7
NB. -------------------------------------------------
NB. Usage: +++draw at once+++
NB. * (0 0 255;4) draw_dpoly0 MC
NB. * (255 0 255;10) draw_dpoly (<MC),<MCPARAM
NB. * ((255 0 255;0 0 255);<10) draw_dpoly_grad (<MC),<MCPARAM
NB. -----------------------------------------------------------
NB. * a=: 4 mk_each_poly (<SP),<SPARAM
NB. *  4 mk_diff_sub0 SPARAM
NB. * 10 mk_diff_sub1 SPARAM
NB. * find_maxmin a

NB.==================================
NB. data block
NB.==================================
NB. Nr.03 井筒組の万字  //01
NB. first piece
IM01=:0 4,0 3,1 3,1 2,0 2,0 1,1 1,:1 0
IM02=:2 0,2 1,3 1,3 0,4 0,4 1,:5 1
IM03=:5 2,4 2,4 3,5 3,5 4,4 4,:4 5
IM04=:3 5,3 4,2 4,2 5,1 5,:1 4
IM=: IM01,IM02,IM03,IM04
NB. center square
IM2=: 2 3,2 2,3 2,: 3 3 
NB. sabun table(1)
IM_16=: _3 12;1 13;5 14;9 15;_2 8;2 9;6 10;10 11
IM_16=: IM_16,_1 4;3 5;7 6;11 7;0 0;4 1;8 2;12 3
IMPARAM=: 0 4;4 1;_1 4
IM2PARAM=: 2 3;4 1;_1 4
NB. ...............................
NB.  _5 0   20 20 dwin 'IZUTU'
NB.  255 0 0 dpoly L:0 IM + "1 L:0 IM_16
NB.  0  255 0 dpoly L:0 IM2 + "1 L:0 IM_16

hokusai_im=: 4 : 0
NB. (246 191 0;244 213 0 ;92 84 36) hokusai_im  6 7
NB. Color 0/1 graduation Color 2 is Center square 
'Color0 Color1 Color2'=. x
Size=. y
((Color0;Color1);<Size)  draw_dpoly_grad (<IM),<IMPARAM
(Color2;Size) draw_dpoly_over (<IM2),<IM2PARAM
)

NB. --------------------------------------------
NB. Nr.17 六つ手万字   //02
NB. 8 fingers Gammadion
NB. 1st piece
NB. MM0=: 10 5,10 3,12 2,12 0,10 1,8 0,6 1,8 2,:8 4
MM0=:10 5, 8 4, 8 2, 6 1, 8 0, 10 1, 12 0, 12 2 ,:10 3
NB. 2nd piece
MM1=: 10 5,10 3,12 2,12 0,14 1,14 3,16 4,14 5,:12 4
MM0PARAM=: 10 5;6 _1;_2 5 NB. for automatic 
MM1PARAM=: 10 5;6 _1;_2 5 NB. same MM0PARAM
NB. point table(4*3) is  hand made
MM_120=: 4 20;10 19;16 18;6 15;12 14;18 13
MM_120=: MM_120,8 10;14 9;20 8;10 5;16 4;22 3
NB. Sabun Table
MM_12=:  MM_120 - L:0 (10 5)
NB.  .......................................... 
hokusai_mm=: 4 : 0
NB. Usage:(67 71 173; 67 90 160) hokusai_mm 6 7
'Color0 Color1'=. x
Size=. y
tmp0=. Size calc_each_poly  (<MM0),<MM0PARAM
tmp2=. Size calc_each_poly  (<MM1),<MM1PARAM
(find_center tmp0) dwin 'Mutsude Manji'
Color0 dpoly L:0  tmp0
Color1 dpoly L:0 tmp2
)

NB. ---------------------------
NB. Nr.18  菱賽型 //03
NB. saigata
S0=: 0 3,3 3,3 2,2 2,2 1,3 1,3 0,: 4 0
S1=: 4 3,5 3,5 2,6 2,6 3,7 3,:7 4
S2=: 4 4,4 5,5 5,5 6,4 6,4 7,:3 7
S3=: 3 4,2 4,2 5,1 5,1 4,:0 4
S=: S0,S1,S2,S3
SPARAM=: 0 3; _1 4;4 1
NB. .............................
hokusai_s=: 4 : 0
NB. Usage:(67 71 173; 67 90 160) hokusai_s 6 7
'Color0 Color1'=. x
Size=. y
((Color0;Color1);<Size) draw_dpoly_grad (<S),<SPARAM
)
NB. -------------------------------
NB. Nr.19  万字つなぎ //04
NB. Manji Tunagi/conected Gamadion 
MT0=: 1 4,1 3,2 3,2 2,1 2,1 1,2 1,2 0,3 0,3 1,:4 1
MT0=:MT0,4 2,3 2,3 3,4 3,4 4,3 4,3 5,2 5,: 2 4
MT1=: 0 6,0 5,1 5,1 4,2 4,2 5,3 5,3 4,4 4,4 5,:5 5
MT1=: MT1,5 6,4 6,4 7,3 7,3 6,2 6,2 7,1 7,:1 6
NB. .................................
MT0PARAM=: 1 4;3 _3;0 6 NB. base xdiff ydiff
MT1PARAM=: 0 6;3 _3;0 6 
NB. ..............................
hokusai_mt=: 4 : 0
NB. Usage:(67 71 173; 67 90 160) hokusai_mt 6 7
'Color0 Color1'=. x
Size=. y
tmp0=. Size calc_each_poly  (<MT0),<MT0PARAM
tmp2=. Size calc_each_poly  (<MT1),<MT1PARAM
(find_center tmp0) dwin 'Connected Manji'
Color0 dpoly L:0  tmp0
Color1 dpoly  L:0 tmp2
)


NB. --------------------------------
NB. Nr. 20 万字菱  //05
NB. Manji Hishi/Diamond Gammadion 
NB. conbinded 2 pieces 
MC0=: 3 3,4 3,4 2,5 2,5 5,6 6,0 6,1 5,4 5,4 4,3 4,: 3 3
MC0=: MC0,3 3,3 2,2 2,2 1,5 1,6 0,0 0,1 1,1 4,2 4,2 3,:3 3
MC0PARAM=: 3 3;6 0;0 6
MC1=: 3 3,2 3,2 4,1 4,1 1,0 0,0 6,1 5,4 5,4 4,:3 4
MC1=: MC1,3 3,3 2,2 2,2 1,5 1,6 0,6 6,5 5,5 2,4 2,:4 3
NB. .......................................
hokusai_mc=: 4 : 0
NB.Usage: (0 164 116 ;169 192 135) hokusai_mc 6 7
'Color0 Color1 '=. x
'Size'=. y
(Color0;Size) draw_dpoly (<MC0),<MC0PARAM
(Color1;Size) draw_dpoly_over (<MC1),<MC0PARAM
(0 0 0;Size) draw_dline_over (<MC0),<MC0PARAM
(0 0 0;Size) draw_dline_over (<MC1),<MC0PARAM
)

hokusai_mc=: 4 : 0
NB. Usage:(67 71 173; 67 90 160) hokusai_mc 6 7
'Color0 Color1'=. x
Size=. y
tmp0=. Size calc_each_poly  (<MC0),<MC0PARAM
tmp2=. Size calc_each_poly  (<MC1),<MC0PARAM
(find_center tmp0) dwin 'Diamond Manji'
Color0 dpoly L:0 tmp0
Color1 dpoly L:0 tmp2
0 0 0  dline L:0 tmp0
)

NB. ------------------------
NB.  Nr. 09 ひょうれつの麻の葉  //06
NB. hemp leaves  
NB. first oieces
HA0=: +. r. 2p1*(i.6)%6  NB. hexagon
HA0PARAM=:1 0 ; 1.5 0.866;0 1.732
NB. Usage:  ((0 120 255;0 255 0);<10 10 )  draw_dpoly_grad (<HA0),<HA0PARAM
HAL0=:0 0, 0 0.866025,0 0,0.75 _0.43317,0 0,:_0.75 _0.43317
HAL1=:0 0, 0 _0.866025,0 0,0.75 0.43317,0 0,:_0.75 0.43317
HAL1PARAM=:HAL0PARAM=: 0 0 ; 1.5 0.86625;0 1.7325
NB. -------------------------------------------------------
hokusai_ha=: 4 : 0
NB.  (144 93 84;230 75 107;0 0 0;144 93 84) hokusai_ha 6 7
'Color0 Color1 Color2 Color3'=. x
Size=. y
tmp0=.Size calc_each_poly (<HAL0),<HAL0PARAM
tmp1=.Size calc_each_poly (<HAL1),<HAL0PARAM
'Ind0 Ind1'=. index_separate Size
'Gr0 Gr1'=. (<Ind0 { ,tmp0),<Ind1{,tmp1
((Color0;Color1);<Size) draw_dpoly_grad (<HA0),<HA0PARAM
Color2 dline L:0 Gr0
Color3 dline L:0 Gr1 
)

NB. ----------------------------------
NB. Nr. 16 麻の葉つくし   //07
NB. various Hemp leaves 
AT=: (4|.|.|."1 HA0),|.1{HA0
NB. adjust on eyes  
ATPARAM=: 0.866 0.5; 0 1.75; 1.5 2.65
ATL=: 0 0,_0.65 0.45, 0 0, 0 _0.75, 0 0 ,: 0.65 0.45  
NB. ...............................................  
hokusai_at=: 4 : 0
NB.  (144 93 84;230 75 107;0 0 0) hokusai_at 6 7
'Color0 Color1 Color2'=. x
Size=. y
((Color0;Color1);<Size) draw_dpoly_grad (<AT),<ATPARAM
(Color2;Size) draw_dline_over (<AT),<ATPARAM
(Color2;Size) draw_dline_over (<ATL),<ATPARAM
NB. Color2 dline L:0 Gr0
NB. Color3 dline L:0 Gr1 
)

NB. -------------------------------------
NB.  Nr. 01  八手麻の葉 //08
NB. 8 hands Hemp leaves
YM0=: 1 1,_1 1,_1 _1 ,1 _1,: 1 1
YML0=: 0 0,_1 1,0 0,_1 _1,0 0,1 _1 , 0 0, 1 1,: 0 0
YML1=: 0 0,0 0.5,1 1,0 0.5,_1 1,0 0.5 ,0 _0.5,1 _1,0 _0.5,: _1 _1
YML2=: |."1 YML1
YMPARAM=: 0 0;2 0;0 2
NB. ............................
NB. draw all at once
hokusai_ym=: 4 : 0
NB.  (0 83 62;170 179 0;170 179 0;0 83 62) hokusai_ym  7 8
NB. color 0 1 ->dpoly 2 3 -> dline 
NB. color 2 3 is reverse of 0 1 or 0 0 0 /255 255 255
'Size'=. y
'Color0 Color1 Color2 '=. x
tmp0=.Size calc_each_poly (<YM0),<YMPARAM
tmp1=.Size calc_each_poly (<YML1),<YMPARAM
tmp2=.Size calc_each_poly (<YML2),<YMPARAM
'Ind0 Ind1'=. index_separate Size
'Gr0 Gr1'=. (<Ind0 { ,tmp0),<Ind1{,tmp0
'Gr2 Gr3'=. (<Ind0 { ,tmp1),<Ind1{,tmp2
popup_dwin tmp0 
Color0 dpoly L:0 Gr0
Color1 dpoly L:0 Gr1 
Color2 dline L:0 Gr2
Color0 dline L:0 Gr3 
)

NB. -------------------
NB. Nr. 10 松川麻の葉  //09
NB. helm leaves like pine needle 
ma0=: 0.5 0.886025
mah1=: 0.28 0.443012
mah2=: 0.22 0.443012
NB. ..........................
MA0=: (_1 1 * ma0),_0.47 0,_0.53 0,(_1 _1*ma0),0.25 _0.463 ,:0.25 _0.403
MA0=: MA0,1 0,0.25 0.463,0.25 0.403,:(_1 1*ma0)
MA1=: 1 1.732 ,0.22 1.299,0.28 1.299,(_1 1*ma0),0.22 0.433 ,:0.28 0.433
MA1=: MA1,1 0,0.97 0.866,1.03 0.866,: 1 1.732
NB. ..............................
MA0PARAM=: _0.5 0.866025;1.5 0.866025;0 1.73205
MA1PARAM=: 1 1.73205;1.5 0.866025;0 1.73205
MAL0PARAM=: 0 0;1.5 0.866025;0 1.73205
MAL1PARAM=: 1 1.73205;1.5 0.866025;0 1.73205
NB. .................................
MAL01=: 0 0 ,_0.22 0.433,_0.28 0.433,_0.5 0.866,_0.28 0.433, _0.22 0.433,: 0 0
MAL02=: _0.22 _0.433,_0.28 _0.433,_0.5 _0.866,_0.28 _0.433, _0.22 _0.433,: 0 0
MAL03=: 0.5 0.03, 0.5 _0.03,: 1 0
MAL0=: MAL01,MAL02,MAL03
MAL04=: 0.5 0.866,0.77 1.299,0.73 1.299 ,1 1.732, 0.73 1.299,0.77 1.299 ,:0.5 0.866
MAL05=: 0 0.886,0 0.846,_0.5 0.866,0 0.846,0 0.886 ,: 0.5 0.866
MAL1=: MAL04,MAL05,0.73 0.433, 0.77 0.433,: 1 0
NB. .............................
hokusai_ma=: 4 : 0
NB.  (169 192 135;151 166 30;0 0 0 ; 104 126 82) hokusai_ma 6 7
NB. y is Size
'Color0 Color1 Color2 Color3'=. x
Size=. y
NB.  (0 83 62;170 179 0;170 179 0;0 83 62) hokusai_ym  7 8
NB. color 0 1 ->dpoly 2 3 -> dline 
NB. color 2 3 is reverse of 0 1 or 0 0 0 /255 255 255
tmp0=.Size calc_each_poly (<MA0),<MA0PARAM
tmp1=.Size calc_each_poly (<MA1),<MA1PARAM
tmp2=.Size calc_each_poly (<MAL0),<MAL0PARAM
tmp3=:Size calc_each_poly (<MAL1),<MAL1PARAM
'Ind0 Ind1'=. index_separate Size
'Gr0 Gr1'=. (<Ind0 { ,tmp0),<Ind1{,tmp0
'Gr2 Gr3'=. (<Ind0 { ,tmp1),<Ind1{,tmp2
popup_dwin tmp0 
Color0 dpoly L:0 Gr0
Color1 dpoly L:0 Gr1 
Color1 dline L:0 Gr1  NB. outline of polygon
Color2 dline L:0 tmp2 NB. on color black line
Color3 dline L:0 tmp3 NB. white off 
)
